MARK_AS_ADVANCED(QT_MACX_INCLUDE_DIR)
FIND_PATH(QT_MACX_INCLUDE_DIR qt_mac.h
  $ENV{QTDIR}/include
  /usr/local/qt/include
  /usr/local/include
  /usr/include/qt3
  /usr/include/qt
  /usr/include
)

IF(QT_MACX_INCLUDE_DIR)
  SET(QT_MACX_FOUND "YES")

  FIND_PATH(QT_INCLUDE_DIR qt_mac.h
    $ENV{QTDIR}/include
    /usr/local/qt/include
    /usr/local/include
    /usr/include/qt3
    /usr/include/qt
    /usr/include
  )

  IF(EXECUTABLE_OUTPUT_PATH)
    SET(APPLE_EXECUTABLE_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
  ELSE(EXECUTABLE_OUTPUT_PATH)
    SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})
    SET(APPLE_EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})
  ENDIF(EXECUTABLE_OUTPUT_PATH)

  MACRO(CREATE_QT_EXECUTABLE
    NAME
    SOURCES
    LIBRARIES
    INSTALL_PREFIX
  )
    SET(APPLE_GUI_EXECUTABLE ${NAME})
    SET(APPLE_GUI_INFO_STRING "Created by Qt/CMake")
    SET(APPLE_GUI_BUNDLE_NAME ${NAME})
    CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/CMakeModules/Templates/AppleInfo.plist
      ${APPLE_EXECUTABLE_OUTPUT_PATH}/${NAME}.app/Contents/Info.plist
    )
    MAKE_DIRECTORY(${APPLE_EXECUTABLE_OUTPUT_PATH}/${NAME}.app/Contents/MacOS)
    ADD_EXECUTABLE(${NAME}.app/Contents/MacOS/${NAME} ${${SOURCES}})
    TARGET_LINK_LIBRARIES(${NAME}.app/Contents/MacOS/${NAME} ${${LIBRARIES}})
    SET_TARGET_PROPERTIES(
      ${NAME}.app/Contents/MacOS/${NAME}
      PROPERTIES
        LINK_FLAGS "-prebind"
    )
    INSTALL_TARGETS(${INSTALL_PREFIX} ${NAME}.app/Contents/MacOS/${NAME})
  ENDMACRO(CREATE_QT_EXECUTABLE)

ELSE(QT_MACX_INCLUDE_DIR)
  MACRO(CREATE_QT_EXECUTABLE
    NAME
    SOURCES
    LIBRARIES
    INSTALL_PREFIX
  )
    ADD_EXECUTABLE(${NAME} ${${SOURCES}})
    TARGET_LINK_LIBRARIES(${NAME} ${${LIBRARIES}})
    INSTALL_TARGETS(${INSTALL_PREFIX} ${NAME})
  ENDMACRO(CREATE_QT_EXECUTABLE)
ENDIF(QT_MACX_INCLUDE_DIR)

FIND_LIBRARY(QT_QT_LIBRARY 
  NAMES qt-mt qt-mt230nc
  PATHS
  $ENV{QTDIR}/lib
  /usr/local/qt/lib
  /usr/local/lib
  /usr/lib
  /usr/share/qt3/lib
  C:/Progra~1/qt/lib
  )

INCLUDE(${CMAKE_ROOT}/Modules/FindQt.cmake)
